/***************************************************************************************
  *
  * IOCTLs.h - Definition File for Kernel Driver IOCTLs
  *   Note: This is the ONLY Header File that can be included both by Kernel and Win32 modules.
  *
  * Copyright (c)2004 VitoPlantamura.COM. All Rights Reserved.
  *
***************************************************************************************/

#pragma once

//========================
// Required Header Files.
//========================

#ifndef VPCKNT_SYSMODULE
	#include <winioctl.h>
#endif

//=====================
// IOCTLs Definitions.
//=====================

#define IOCTL_DPCSTKGRNT_INITIALIZE				CTL_CODE(IOCTL_UNKNOWN_BASE, 0x0800, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_DPCSTKGRNT_GET_VERSION			CTL_CODE(IOCTL_UNKNOWN_BASE, 0x0801, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

//=================================
// IOCTLs Related Data Structures.
//=================================

#pragma pack(push, 1)

	// --> IOCTL_DPCSTKGRNT_INITIALIZE <--

	typedef struct _INITIALIZE_INPUT
	{
		// new kernel stack size for KiRetireDpcList, in kbytes.

		ULONG		ulStackSizeInKBytes;

	} INITIALIZE_INPUT, *PINITIALIZE_INPUT;

	typedef struct _INITIALIZE_OUTPUT
	{
		// ...status...

		ULONG		bSucceeded;
		PVOID		dwKiRetireDpcListFnAddr;

	} INITIALIZE_OUTPUT, *PINITIALIZE_OUTPUT;

	#define INITIALIZE_INPUT_SIZE				( sizeof( INITIALIZE_INPUT ) )
	#define INITIALIZE_OUTPUT_SIZE				( sizeof( INITIALIZE_OUTPUT ) )

#pragma pack(pop)

//======================
// General Definitions.
//======================

#define FILE_DEVICE_UNKNOWN             0x00000022
#define IOCTL_UNKNOWN_BASE              FILE_DEVICE_UNKNOWN

//================================================
// Definitions about the Driver Version and Name.
//================================================

#define SYSDRIVER_NAME_ANSI			"VPCDpcSG"	// Name of the Driver and Device.
#define SYSDRIVER_NAME_WIDE			L"VPCDpcSG"	//   "      "      "      "

#define _VPCDpcSG_DRIVER_VERSION_		( 1 )		// Driver Version actually in use.
