/***************************************************************************************
  *
  * dpcstkgr.h - Kernel Module Primary Header File
  *
  * Copyright (c)2004 VitoPlantamura.COM. All Rights Reserved.
  *
***************************************************************************************/

#pragma once

//===========
// Includes.
//===========

#include <ntddk.h>

//========
// Types.
//========

typedef unsigned long			DWORD;
typedef int						INT;

//==========
// Defines.
//==========

#define MACRO_KIRETIREDPCLIST_FNSRCH_RANGE					( 0x5000 )

#define MACRO_KIRETIREDPCLIST_FNSRCH_W2KSMPFREE_1STBYTE		( 0x56 )		// Windows 2000 Service Pack 4 SMP FREE.
#define MACRO_KIRETIREDPCLIST_FNSRCH_W2KSMPFREE_2NDDWORD	( 0x0848B38D )	//		"		"
#define MACRO_KIRETIREDPCLIST_FNSRCH_W2KSMPFREE_3NDDWORD	( 0x89640000 )	//		"		"

#define MACRO_KIRETIREDPCLIST_FNSRCH_WXPSMPFREE_1STBYTE		( 0x56 )		// Windows XP Service Pack 2 SMP FREE.
#define MACRO_KIRETIREDPCLIST_FNSRCH_WXPSMPFREE_2NDDWORD	( 0x09C0B38D )	//		"		"
#define MACRO_KIRETIREDPCLIST_FNSRCH_WXPSMPFREE_3NDDWORD	( 0x006A0000 )	//		"		"

#define MACRO_KIRETIREDPCLIST_FNSRCH_W2KUPFREE_1STBYTE		( 0x89 )		// Windows 2000 Service Pack 4 UP FREE.
#define MACRO_KIRETIREDPCLIST_FNSRCH_W2KUPFREE_2NDDWORD		( 0xDFF80C25 )	//		"		"
#define MACRO_KIRETIREDPCLIST_FNSRCH_W2KUPFREE_3NDDWORD		( 0x00558BFF )	//		"		"

#define MACRO_KIRETIREDPCLIST_FNSRCH_WXPUPFREE_1STBYTE		( 0x6A )		// Windows XP Service Pack 1 UP FREE.
#define MACRO_KIRETIREDPCLIST_FNSRCH_WXPUPFREE_2NDDWORD		( 0x0CEC8300 )	//		"		"
#define MACRO_KIRETIREDPCLIST_FNSRCH_WXPUPFREE_3NDDWORD		( 0xEBEC3D83 )	//		"		"

#define MACRO_MAX_NUMBERPROCESSORS						( 32 )

//=============
// Structures.
//=============

// --> hook per-processor structure. <--

typedef struct _PERPROC_DPCSTACK_STATE
{
	PVOID			pvNewStack; // ### allocated from NonPagedPool... ###
	PVOID			pvRefPcr; // ### 0 if this stack was not already assigned... ###

	DWORD			dwNewStackPointer; // ### NEW SP... ###

} PERPROC_DPCSTACK_STATE, *PPERPROC_DPCSTACK_STATE;

// --> Device Extension Structure Definition. <--

typedef struct _DEVICE_EXTENSION 
{
	// Boolean that indicates whether the user mode service/application has created the file object.

	ULONG			WasCreated;
	FAST_MUTEX		WasCreatedFastMutex;

	// Hook specific stuff.

	DWORD							dwNumberProcessors;
	PERPROC_DPCSTACK_STATE			vppdssState[ MACRO_MAX_NUMBERPROCESSORS ];

	KSPIN_LOCK						slStateSpinLock;
	__declspec( align( 4 ) ) ULONG	ulUseStateSpinLock;
	ULONG							ulNumProcAllocated;

} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

// --> Externs <--

extern PDEVICE_OBJECT		g_pDeviceObject;

//==========
// Externs.
//==========

NTKERNELAPI VOID NTAPI KiDeliverApc( DWORD, DWORD, DWORD ); // THE ACTUAL, EXACT PROTOTYPE DOES NOT INTEREST US...
NTKERNELAPI VOID NTAPI KiCoprocessorError( VOID ); // THE ACTUAL, EXACT PROTOTYPE DOES NOT INTEREST US...
NTKERNELAPI VOID NTAPI KiDispatchInterrupt( VOID ); // THE ACTUAL, EXACT PROTOTYPE DOES NOT INTEREST US...

//=============
// Prototypes.
//=============

NTSTATUS IsEnforceWriteProtectionSetTo0( OUT BOOLEAN* pbResult );
PVOID Guess_KiRetireDpcList_FnPtr( VOID );
